function buildWorld(maxx, maxz)
{
   world = new Object();
   world.maxx = maxx;
   world.maxz = maxz;
   world.cellWidth = 29;
   world.angleOffset = 7;
   world.width = maxx * world.cellWidth;
   world.length = (- maxz) * world.cellWidth;
   world.path = this.floor_mc;
   var path = world.path;
   buildFloor(path);
   buildCharacter(path);
   world.badGuysArray = new Array();
   world.goalObjArray = new Array();
   world.distItemsArray = new Array();
   world.activeInv = 0;
}
function buildCharacter(path)
{
   world.char = new Object();
   world.char.tempx = eval("BeginX" + gameMC.gLevel);
   world.char.tempy = 0;
   world.char.tempz = eval("BeginZ" + gameMC.gLevel);
   world.char.speed = 4;
   world.char.feeler = 10;
   world.char.width = 10;
   world.char.xmov = 0;
   world.char.zmov = 0;
   world.char.x_tile = 0;
   world.char.z_tile = 0;
   world.char.moving = false;
   world.char.invisible = false;
   world.char.teleporting = false;
   world.char.clip = path.character;
   positionCharacter(world.char);
}
function positionCharacter(obj)
{
   obj.x = obj.tempx;
   obj.y = obj.tempy;
   obj.z = obj.tempz;
   var temp = iso.mapToScreen(obj.x,obj.y,obj.z);
   obj.clip._x = temp[0];
   obj.clip._y = temp[1];
}
function buildFloor(path)
{
   path.tile._visible = false;
   world.tiles = [];
   var y = 0;
   var j = 1;
   while(j <= 20)
   {
      var i = 1;
      while(i <= 20)
      {
         if(j == 1)
         {
            world.tiles[i] = [];
         }
         var depth = iso.calculateDepth(i,y,j);
         var name = "cell" + i + "_" + j;
         path.attachMovie("tile",name,depth);
         var clip = path[name];
         world.tiles[i][j] = {x:i,y:y,z:j,depth:depth,clip:clip,isObject:false,pickup:false,invIndx:null,distractor:false};
         var x = (i - 1) * world.cellWidth;
         var z = (- (j - 1)) * world.cellWidth;
         temp = iso.mapToScreen(x,y,z);
         clip._x = temp[0];
         clip._y = temp[1];
         i++;
      }
      j++;
   }
}
function makeObject(x, z, object, pickupable, indx, found, distractor)
{
   world.tiles[x][z].isObject = true;
   world.tiles[x][z].clip.objects.gotoAndStop(object);
   world.tiles[x][z].pickup = pickupable;
   world.tiles[x][z].invIndx = indx;
   world.tiles[x][z].distractor = distractor;
   if(eval("InvOrder" + gameMC.gLevel) and indx > 0)
   {
      world.tiles[x][z].clip.objects.Brick_mc.gotoAndStop("UnLit");
   }
   else
   {
      world.tiles[x][z].clip.objects.Brick_mc.gotoAndStop("Lit");
   }
}
function clearObject(x, z)
{
   world.tiles[x][z].isObject = false;
   world.tiles[x][z].clip.objects.gotoAndStop(1);
   world.tiles[x][z].pickup = false;
   world.tiles[x][z].invIndx = null;
   world.tiles[x][z].distractor = null;
}
function makeTeleporter(x, z, endx, endz)
{
   world.tiles[x][z].isObject = true;
   world.tiles[x][z].clip.objects.gotoAndStop("teleport");
   world.tiles[x][z].pickup = false;
   world.tiles[x][z].invIndx = [endx,endz];
   world.tiles[x][z].distractor = "teleport";
}
function fnTeleportDone()
{
   var tArray = this["Tele" + gameMC.gLevel + "Array"];
   var x1 = tArray[gameMC.activeTeleIndx][0];
   var z1 = tArray[gameMC.activeTeleIndx][1];
   var x2 = tArray[gameMC.activeTeleIndx][2];
   var z2 = tArray[gameMC.activeTeleIndx][3];
   fnKillTele(x1,z1);
   fnKillTele(x2,z2);
   world.char.teleporting = false;
}
function fnKillTele(xtile, ztile)
{
   world.tiles[xtile][ztile].isObject = false;
   world.tiles[xtile][ztile].distractor = false;
   world.tiles[xtile][ztile].pickup = false;
   world.tiles[xtile][ztile].invIndx = null;
   world.tiles[xtile][ztile].clip.objects.gotoAndStop(1);
}
function fnMakeSuperCoin()
{
   clearInterval(world.superCoinTimer);
   var xtile;
   var ztile;
   var emptyfound = false;
   do
   {
      var xt = Math.floor(Math.random() * 18) + 2;
      var zt = Math.floor(Math.random() * 18) + 2;
      var notincorner = true;
      if(xt < 5 and zt < 5 or zt >= 10 and xt <= zt - 12 or xt > 10 and zt < xt - 10 or xt > 17 and zt > 16)
      {
         notincorner = false;
      }
      if(notincorner)
      {
         if(fnCheckEmpty(xt,zt))
         {
            xtile = xt;
            ztile = zt;
            emptyfound = true;
         }
      }
   }
   while(!emptyfound);
   
   gameMC.gSuperX = xtile;
   gameMC.gSuperZ = ztile;
   gameMC.gSuperOn = true;
   makeObject(gameMC.gSuperX,gameMC.gSuperZ,"supercoin",true,"supercoin",false,true);
   gameMC.gLastSuperCoinChange = getTimer();
}
function fnKillSuperCoin()
{
   gameMC.gSuperOn = false;
   world.tiles[gameMC.gSuperX][gameMC.gSuperZ].isObject = false;
   world.tiles[gameMC.gSuperX][gameMC.gSuperZ].distractor = false;
   world.tiles[gameMC.gSuperX][gameMC.gSuperZ].pickup = false;
   world.tiles[gameMC.gSuperX][gameMC.gSuperZ].invIndx = null;
   world.tiles[gameMC.gSuperX][gameMC.gSuperZ].clip.objects.SuperCoin_mc.gotoAndPlay("Out");
   gameMC.gSuperZ = null;
   gameMC.gSuperX = null;
   world.superCoinTimer = setInterval(fnMakeSuperCoin,5000);
}
function changeGroundTile(x, z, object)
{
   world.tiles[x][z].clip.innerTile.gotoAndStop(object);
}
function changeManyGroundTiles(x, xnum, z, znum, object)
{
   var i = 0;
   while(i < xnum)
   {
      var j = 0;
      while(j < znum)
      {
         world.tiles[x + i][z + j].clip.innerTile.gotoAndStop(object);
         j++;
      }
      i++;
   }
}
function fnClearInvisible()
{
   clearInterval(world.invisibleTimer);
   trace("Clearing Invis");
   world.char.invisible = false;
}
function fnCheckAvatars(myxtile, myztile)
{
   var charsempty = true;
   if(world.char.x_tile == myxtile and world.char.z_tile == myztile)
   {
      charsempty = false;
   }
   var i = 0;
   while(i < world.badGuysArray.length)
   {
      if(world.badGuysArray[i].x_tile == myxtile and world.badGuysArray[i].z_tile == myztile)
      {
         charsempty = false;
      }
      i++;
   }
   return charsempty;
}
function fnCheckEmpty(myxtile, myztile)
{
   empty = fnCheckAvatars(myxtile,myztile);
   if(world.tiles[myxtile][myztile].isObject)
   {
      empty = false;
   }
   var tArray = this["Tele" + gameMC.gLevel + "Array"];
   var i = 0;
   while(i < tArray.length)
   {
      if(tArray[i][0] == myxtile and tArray[i][1] == myztile)
      {
         empty = false;
      }
      if(tArray[i][2] == myxtile and tArray[i][3] == myztile)
      {
         empty = false;
      }
      i++;
   }
   var mArray = eval("FWalls" + gameMC.gLevel + "Array");
   var i = 0;
   while(i < mArray.length)
   {
      if(mArray[i][0] == myxtile and mArray[i][1] == myztile)
      {
         empty = false;
      }
      i++;
   }
   var dArray = this["Other" + gameMC.gLevel + "Array"];
   var i = 0;
   while(i < dArray.length)
   {
      if(dArray[i][0] == myxtile and dArray[i][1] == myztile)
      {
         empty = false;
      }
      i++;
   }
   return empty;
}
function pickUpDistObject(tilex, tilez, invindx)
{
   world.tiles[tilex][tilez].isObject = false;
   world.tiles[tilex][tilez].pickup = false;
   world.tiles[tilex][tilez].clip.objects.gotoAndStop(1);
   switch(invindx)
   {
      case "cloak":
         SFX_MC.gotoAndPlay("cloak");
         trace("You picked up the cloak");
         world.char.invisible = true;
         world.invisibleTimer = setInterval(fnClearInvisible,gameMC.INVISIBLETIME);
         break;
      case "token15":
         SFX_MC.gotoAndPlay("fifteen");
         fnScore(15);
         break;
      case "token25":
         SFX_MC.gotoAndPlay("twentyfive");
         fnScore(25);
         break;
      case "supercoin":
         SFX_MC.gotoAndPlay("twofifty");
         gameMC.gSuperZ = null;
         gameMC.gSuperX = null;
         gameMC.gSuperOn = false;
         gameMC.gLastSuperCoinChange = getTimer();
         SFX_MC.gotoAndPlay("supercoin");
         fnScore(250);
         world.superCoinTimer = setInterval(fnMakeSuperCoin,5000);
         break;
      default:
         trace("Not sure what you picked up");
   }
}
function pickUpInvObject(tilex, tilez, invindx)
{
   trace("Picking " + tilex + " " + tilez + " " + invindx);
   if(invIndx != world.activeInv and eval("InvOrder" + gameMC.gLevel))
   {
      fnShowMessage("That\'s not the next item.");
   }
   else
   {
      AudioTile_MC.play();
      world.activeInv = world.activeInv + 1;
      world.tiles[tilex][tilez].isObject = false;
      world.tiles[tilex][tilez].pickup = false;
      world.tiles[tilex][tilez].clip.objects.gotoAndStop(1);
      inventory_mc["inv" + Invindx + "_mc"].gotoAndPlay("visible");
      world.goalObjArray[Invindx][3] = true;
      fnScore(gameMC.BRICKPOINTS);
      var allFound = true;
      var i = 0;
      while(i < world.goalObjArray.length)
      {
         if(!world.goalObjArray[i][3])
         {
            allFound = false;
            break;
         }
         i++;
      }
      if(allFound)
      {
         gameMC.fnStopFrameActions();
         gameMC.levelComplete = true;
         gameMC.ReplayAllowed = true;
         world.char.clip.gotoAndStop("stand" + world.char.frame);
         var z = 0;
         while(z < world.badGuysArray.length)
         {
            world.badGuysArray[z].clip.gotoAndStop("Stand" + world.badGuysArray[z].dir);
            z++;
         }
      }
      else
      {
         var nextTileX = world.goalObjArray[world.activeInv][0];
         var nextTileZ = world.goalObjArray[world.activeInv][1];
         fnShowMessage(world.goalObjArray.length - world.activeInv + " more to go!");
         world.tiles[nextTileX][nextTileZ].clip.objects.Brick_mc.gotoAndStop("Lit");
      }
   }
}
function moveCharacter()
{
   if(world.char.moving and !gameMC.world.char.teleporting)
   {
      world.char.tempx = world.char.x + world.char.xmov;
      world.char.tempz = world.char.z + world.char.zmov;
      world.char.tempy = world.char.y + world.char.ymov;
      var sx = world.char.startx;
      var sz = world.char.startz;
      var ex = world.char.endx;
      var ez = world.char.endz;
      var tempx = world.char.tempx;
      var tempz = world.char.tempz;
      if((ex - sx) / Math.abs(ex - sx) != (ex - tempx) / Math.abs(ex - tempx) || (ez - sz) / Math.abs(ez - sz) != (ez - tempz) / Math.abs(ez - tempz))
      {
         var lastkey = Key.getCode();
         if(lastkey == world.char.movKey and (Key.isDown(100) or Key.isDown(102) or Key.isDown(99) or Key.isDown(97) or Key.isDown(85) or Key.isDown(79) or Key.isDown(74) or Key.isDown(76) or Key.isDown(81) or Key.isDown(69) or Key.isDown(65) or Key.isDown(68) or Key.isDown(37) or Key.isDown(38) or Key.isDown(39) or Key.isDown(40)))
         {
            var newx;
            var newy;
            if(Key.isDown(102) or Key.isDown(69) or Key.isDown(79) or Key.isDown(39))
            {
               var newx = world.char.clip._x + world.cellWidth / 2;
               newy = world.char.clip._y - (world.cellWidth / 2 - world.angleOffset);
            }
            else if(Key.isDown(100) or Key.isDown(85) or Key.isDown(81) or Key.isDown(38))
            {
               var newx = world.char.clip._x - world.cellWidth / 2;
               newy = world.char.clip._y - (world.cellWidth / 2 - world.angleOffset);
            }
            else if(Key.isDown(99) or Key.isDown(76) or Key.isDown(68) or Key.isDown(40))
            {
               newx = world.char.clip._x + world.cellWidth / 2;
               var newy = world.char.clip._y + (world.cellWidth / 2 - world.angleOffset);
            }
            else if(Key.isDown(97) or Key.isDown(74) or Key.isDown(65) or Key.isDown(37))
            {
               newx = world.char.clip._x - world.cellWidth / 2;
               var newy = world.char.clip._y + (world.cellWidth / 2 - world.angleOffset);
            }
            var temp = iso.mapToIsoWorld(newx,newy);
            world.char.endx = temp[0];
            world.char.endz = temp[1];
         }
         else
         {
            world.char.moving = false;
            world.char.xmov = 0;
            world.char.zmov = 0;
            world.char.tempx = ex;
            world.char.tempz = ez;
            world.char.clip.gotoAndStop("stand" + world.char.frame);
         }
      }
   }
}
function detectObjects()
{
   var x = world.char.tempx + world.char.feelerx;
   var z = Math.abs(world.char.tempz + world.char.feelerz);
   var x_tile = Math.ceil(x / world.cellWidth);
   var z_tile = Math.ceil(z / world.cellWidth);
   if(world.tiles[x_tile][z_tile].isObject != true || world.tiles[x_tile][z_tile].pickup || world.tiles[x_tile][z_tile].distractor == "teleport")
   {
      var x = world.char.tempx;
      var z = Math.abs(world.char.tempz);
      var x_tile = Math.ceil(x / world.cellWidth);
      var z_tile = Math.ceil(z / world.cellWidth);
      if(world.tiles[x_tile][z_tile].distractor == "teleport" and !world.char.teleporting)
      {
         AudioTeleport_MC.gotoAndPlay("down");
         world.char.teleporting = true;
         world.char.moving = false;
         fnScore(gameMC.TELEPOINTS);
         var tArray = this["Tele" + gameMC.gLevel + "Array"];
         var i = 0;
         while(i < tArray.length)
         {
            var match = false;
            var targxCol;
            var targzCol;
            if(x_tile == tArray[i][0] and z_tile == tArray[i][1])
            {
               match = true;
               var targxCol = tArray[i][2];
               var targzCol = tArray[i][3];
            }
            else if(x_tile == tArray[i][2] and z_tile == tArray[i][3])
            {
               match = true;
               var targxCol = tArray[i][0];
               var targzCol = tArray[i][1];
            }
            if(match)
            {
               trace("Teleport to x" + targxCol + " col" + targzCol);
               world.char.clip._visible = 0;
               world.tiles[x_tile][z_tile].clip.objects.portal_mc.targxCol = targxCol;
               world.tiles[x_tile][z_tile].clip.objects.portal_mc.targZCol = targzCol;
               world.tiles[x_tile][z_tile].clip.objects.portal_mc.gotoAndStop("enter");
               var newx = world.tiles[targxCol][targzCol].clip._x;
               var newy = world.tiles[targxCol][targzCol].clip._y + world.cellWidth / 6;
               var temp = iso.mapToIsoWorld(newx,newy);
               world.char.endx = temp[0];
               world.char.endz = temp[1];
               world.char.tempx = temp[0];
               world.char.tempz = temp[1];
               world.char.xmov = 0;
               world.char.zmov = 0;
               x_tile = targxCol;
               z_tile = targzCol;
               break;
            }
            i++;
         }
      }
      world.char.x_tile = x_tile;
      world.char.z_tile = z_tile;
      var depth = world.tiles[x_tile][z_tile].depth + 2;
      world.char.clip.swapDepths(depth);
      if(world.tiles[x_tile][z_tile].pickup)
      {
         var invindx = world.tiles[x_tile][z_tile].invIndx;
         if(world.tiles[x_tile][z_tile].distractor)
         {
            pickUpDistObject(x_tile,z_tile,invindx);
         }
         else
         {
            pickUpInvObject(x_tile,z_tile,invindx);
         }
      }
      gameMC.charX = x;
      gameMC.charZ = z;
      gameMC.charXTile = world.char.x_tile;
      gameMC.charZTile = world.char.z_tile;
   }
   else
   {
      world.char.tempx = world.char.x;
      world.char.tempz = world.char.z;
      world.char.xmov = 0;
      world.char.ymov = 0;
      world.char.moving = false;
      var frame = world.char.frame;
      world.char.clip.gotoAndStop("stand" + frame);
   }
}
function fnCheckDeath()
{
   var i = 0;
   while(i < world.badGuysArray.length)
   {
      var ob = world.badGuysArray[i];
      var x_tile = ob.x_tile;
      var z_tile = ob.z_tile;
      if(x_tile == world.char.x_tile and z_tile == world.char.z_tile and world.char.invisible != true)
      {
         var thiskillTime = getTimer();
         var timediff = thiskillTime - gameMC.gLastKillTime;
         if(timediff > gameMC.KILLDELAY or gameMC.gLastKillTime == null)
         {
            gameMC.gLastKillTime = thiskillTime;
            gameMC.gKills = gameMC.gKills + 1;
            SFX_MC.gotoAndPlay("looseonelife");
            world.char.clip.hit_mc.gotoAndPlay("Hit");
            Kills_mc.gotoAndStop(gameMC.gKills + 1);
            if(gameMC.gKills >= 3)
            {
               fnLevelComplete("Dead");
            }
            else
            {
               gameMC.fnStopFrameActions();
               gameMC.levelActive = false;
               gameMC.pausestart = getTimer();
               clearInterval(world.invisibleTimer);
               clearInterval(world.superCoinTimer);
               GameAlert_mc.gotoAndStop("Hit");
               GameAlert_mc._visible = 1;
            }
         }
      }
      i++;
   }
}
function fnLevelComplete(state)
{
   gameMC.fnStopFrameActions();
   gameMC.levelActive = false;
   fnStopMusic();
   world.char.clip._visible = 1;
   world.char.clip.gotoAndStop("stand1");
   clearInterval(world.invisibleTimer);
   clearInterval(world.superCoinTimer);
   var i = 0;
   while(i < world.tiles.length)
   {
      var z = 0;
      while(z < world.tiles[i].length)
      {
         world.tiles[i][z].clip.removeMovieClip();
         z++;
      }
      i++;
   }
   var i = 0;
   while(i < world.goalObjArray.length)
   {
      this["inv" + i].removeMovieClip();
      i++;
   }
   var z = 0;
   while(z < world.badGuysArray.length)
   {
      world.badGuysArray[z].clip.removeMovieClip();
      z++;
   }
   delete world;
   fnHideMessage();
   if(state == "Level")
   {
      SFX_MC.gotoAndPlay("madeIt");
      MapClip.Map_mc.gotoAndStop("Level" + gameMC.gLevel);
      MapClip._visible = 1;
   }
   else
   {
      gameMC.pausestart = getTimer();
      SFX_MC.gotoAndPlay("gameover");
      GameAlert_mc.gotoAndStop(state);
      GameAlert_mc._visible = 1;
   }
}
function fnContinue()
{
   gameMC.levelComplete = false;
   gameMC.levelActive = true;
   GameAlert_mc._visible = 0;
   GameAlert_mc.gotoAndStop("Park");
   var now = getTimer();
   gameMC.gLastWallChange = now;
   gameMC.gLastTeleChange = now;
   var timeaway = now - gameMC.pausestart;
   gameMC.endTime += timeaway;
   var i = 0;
   while(i < world.badGuysArray.length)
   {
      trace("Deleting " + world.badGuysArray[i].clip);
      world.badGuysArray[i].clip.removeMovieClip();
      i++;
   }
   world.badGuysArray = new Array();
   var tempBadArray = eval("Bad" + gameMC.gLevel + "Array");
   var m = 0;
   while(m < tempBadArray.length)
   {
      fnBadGuy(tempBadArray[m][0],tempBadArray[m][1],tempBadArray[m][2]);
      m++;
   }
   world.char.tempx = eval("BeginX" + gameMC.gLevel);
   world.char.tempy = 0;
   world.char.tempz = eval("BeginZ" + gameMC.gLevel);
   world.char.xmov = 0;
   world.char.zmov = 0;
   world.char.x_tile = 0;
   world.char.z_tile = 0;
   world.char.moving = false;
   world.char.invisible = false;
   world.char.teleporting = false;
   positionCharacter(world.char);
   fnStartFrameActions();
}
function fnRestartGame(startlevel)
{
   gameMC.gScore = 0;
   gameMC.gKills = 0;
   Kills_mc.gotoAndStop(1);
   score_txt.text = "0";
   MapClip._visible = 0;
   MapClip.Map_mc.gotoAndStop("Park");
   if(startlevel > 1)
   {
      gameMC.gLevel = startlevel - 1;
      fnInitLevel();
   }
   else
   {
      gameMC.LASTLEVEL = 4;
      gameMC.gLevel = 0;
      GameAlert_mc.gotoAndStop("Help");
      GameAlert_mc._visible = 1;
   }
}
function fnInitLevel()
{
   gameMC.levelComplete = false;
   gameMC.levelActive = true;
   gameMC.ReplayScore = gameMC.gScore;
   gameMC.ReplayKills = gameMC.gKills;
   gameMC.gLevel = gameMC.gLevel + 1;
   level_txt.text = gameMC.gLevel;
   mazebg_mc.gotoAndStop(gameMC.gLevel);
   GameAlert_mc._visible = 0;
   GameAlert_mc.gotoAndStop("Park");
   MapClip._visible = 0;
   MapClip.Map_mc.gotoAndStop("Park");
   gameMC.activeTeleIndx = 0;
   gameMC.activeWallIndx = 0;
   gameMC.LEVELTIME = eval("L" + gameMC.gLevel + "Time") * 1000;
   var now = getTimer();
   gameMC.gLastWallChange = now;
   gameMC.gLastTeleChange = now;
   maxx = 20;
   maxz = 20;
   iso = new isometricAS(maxx,maxz);
   buildWorld(maxx,maxz);
   var tempMazeArray = eval("Maze" + gameMC.gLevel + "Array");
   var m = 0;
   while(m < tempMazeArray.length)
   {
      makeObject(tempMazeArray[m][0],tempMazeArray[m][1],"block" + tempMazeArray[m][2]);
      m++;
   }
   inventory_mc.gotoAndStop(gameMC.gLevel);
   world.goalObjArray = this["Inv" + gameMC.gLevel + "Array"];
   var i = 0;
   while(i < world.goalObjArray.length)
   {
      makeObject(world.goalObjArray[i][0],world.goalObjArray[i][1],world.goalObjArray[i][2],true,i,false,false);
      world.goalObjArray[i][3] = false;
      inventory_mc["inv" + Invindx + "_mc"].gotoAndStop(1);
      i++;
   }
   var tempBadArray = eval("Bad" + gameMC.gLevel + "Array");
   var m = 0;
   while(m < tempBadArray.length)
   {
      fnBadGuy(tempBadArray[m][0],tempBadArray[m][1],tempBadArray[m][2]);
      m++;
   }
   var tOtherArray = this["Other" + gameMC.gLevel + "Array"].copy();
   var z = 0;
   do
   {
      var xt = Math.floor(Math.random() * 18) + 2;
      var zt = Math.floor(Math.random() * 18) + 2;
      var notincorner = true;
      if(xt < 5 and zt < 5 or zt >= 10 and xt <= zt - 12 or xt > 10 and zt < xt - 10 or xt > 17 and zt > 16)
      {
         notincorner = false;
      }
      if(notincorner)
      {
         if(fnCheckEmpty(xt,zt))
         {
            var rndnum = Math.floor(Math.random() * 4);
            if(rndnum == 1)
            {
               tOtherArray.push([xt,zt,"token25",false,true]);
            }
            else
            {
               tOtherArray.push([xt,zt,"token15",false,true]);
            }
            z++;
         }
      }
   }
   while(z < gameMC.TOKENCOUNT);
   
   world.distItemsArray = tOtherArray;
   var i = 0;
   while(i < world.distItemsArray.length)
   {
      makeObject(world.distItemsArray[i][0],world.distItemsArray[i][1],world.distItemsArray[i][2],true,world.distItemsArray[i][2],false,true);
      world.distItemsArray[i][3] = false;
      i++;
   }
   fnMakeSuperCoin();
   gameMC.endTime = Number(getTimer() + gameMC.LEVELTIME);
   fnStartMusic();
   fnStartFrameActions();
}
function fnRePlayLevel()
{
   gameMC.ReplayAllowed = false;
   gameMC.gLevel--;
   gameMC.gScore = gameMC.ReplayScore;
   gameMC.gKills = gameMC.ReplayKills;
   Kills_mc.gotoAndStop(gameMC.gKills + 1);
   score_txt.text = gameMC.gScore;
   fnInitLevel();
}
function fnStopFrameActions()
{
   gameMC.onEnterFrame = "";
}
function fnStartFrameActions()
{
   gameMC.onEnterFrame = function()
   {
      moveCharacter();
      detectObjects();
      positionCharacter(world.char);
      fnMoveBadGuys();
      fnBadGuyAI();
      if(!world.char.moving)
      {
         fnCaptureKeys();
      }
      fnCheckTimer();
      fnCheckDeath();
   };
}
function fnCheckTimer()
{
   var now = getTimer();
   var end = gameMC.endTime;
   var timeleft = (end - now) / 1000;
   minleft = Math.floor(timeleft / 60);
   secleft = Math.floor(timeleft - minleft * 60);
   if(minleft < 10)
   {
      minleft = "0" + minleft;
   }
   if(secleft < 10)
   {
      secleft = "0" + secleft;
   }
   minleft_txt.text = minleft;
   secLeft_txt.text = secleft;
   if(timeleft < 1)
   {
      fnLevelComplete("OutOfTime");
   }
   if(now - gameMC.MsgTime > gameMC.MSGDELAY and Message_mc._visible == 1)
   {
      fnHideMessage();
   }
   else
   {
      Message_mc._x = world.char.clip._x + 220;
      Message_mc._y = world.char.clip._y;
   }
   var tempMazeArray = eval("FWalls" + gameMC.gLevel + "Array");
   if(now - gameMC.gLastWallChange > gameMC.WALLDELAY and tempMazeArray.length > 1)
   {
      gameMC.gLastWallChange = now;
      var m = 0;
      while(m < tempMazeArray.length)
      {
         var xtile = tempMazeArray[m][0];
         var ztile = tempMazeArray[m][1];
         if(world.tiles[xtile][ztile].clip.objects._currentframe > 1 and (world.char.x_tile != xtile and world.char.z_tile != ztile))
         {
            world.tiles[xtile][ztile].clip.objects.block_mc.gotoAndPlay("fade_out");
         }
         m++;
      }
      gameMC.activeWallIndx += gameMC.WALLCOUNT;
      if(gameMC.activeWallIndx >= tempMazeArray.length)
      {
         gameMC.activeWallIndx = 0;
      }
      var endIndex = gameMC.activeWallIndx + gameMC.WALLCOUNT;
      var m = gameMC.activeWallIndx;
      while(m != endIndex)
      {
         if(m >= tempMazeArray.length)
         {
            m = 0;
            endIndex -= tempMazeArray.length;
         }
         var xtile = tempMazeArray[m][0];
         var ztile = tempMazeArray[m][1];
         var shape = tempMazeArray[m][2];
         world.tiles[xtile][ztile].clip.objects.xtile = xtile;
         world.tiles[xtile][ztile].clip.objects.ztile = ztile;
         world.tiles[xtile][ztile].clip.objects.dynamicWall = true;
         makeObject(xtile,ztile,"block" + shape);
         m++;
      }
   }
   var tArray = this["Tele" + gameMC.gLevel + "Array"];
   if(now - gameMC.gLastTeleChange > gameMC.TELEDELAY and tArray.length > 1 and !world.char.teleporting)
   {
      gameMC.gLastTeleChange = now;
      fnKillTele(tArray[gameMC.activeTeleIndx][0],tArray[gameMC.activeTeleIndx][1],tArray[gameMC.activeTeleIndx][2],tArray[gameMC.activeTeleIndx][3]);
      fnKillTele(tArray[gameMC.activeTeleIndx][2],tArray[gameMC.activeTeleIndx][3],tArray[gameMC.activeTeleIndx][0],tArray[gameMC.activeTeleIndx][1]);
      gameMC.activeTeleIndx = gameMC.activeTeleIndx + 1;
      if(gameMC.activeTeleIndx > tArray.length - 1)
      {
         gameMC.activeTeleIndx = 0;
      }
      makeTeleporter(tArray[gameMC.activeTeleIndx][0],tArray[gameMC.activeTeleIndx][1],tArray[gameMC.activeTeleIndx][2],tArray[gameMC.activeTeleIndx][3]);
      makeTeleporter(tArray[gameMC.activeTeleIndx][2],tArray[gameMC.activeTeleIndx][3],tArray[gameMC.activeTeleIndx][0],tArray[gameMC.activeTeleIndx][1]);
   }
   if(gameMC.gSuperOn and now - gameMC.gLastSuperCoinChange > gameMC.SUPERCOINDELAY - gameMC.glevel * 500)
   {
      fnKillSuperCoin();
   }
}
function fnHideMessage()
{
   Message_mc._visible = 0;
   Message_mc.onMouseDown = "";
}
function fnShowMessage(msgString)
{
   Message_mc._x = world.char.clip._x + 220;
   Message_mc._y = world.char.clip._y;
   Message_mc._visible = 1;
   Message_mc.msg_txt.text = msgString;
   Message_mc.onMouseDown = function()
   {
      fnHideMessage();
   };
   gameMC.MsgTime = getTimer();
}
function fnScore(points)
{
   gameMC.gScore += points;
   score_txt.text = gameMC.gScore;
   EarnPoint_mc._x = world.char.clip._x + 190;
   EarnPoint_mc._y = world.char.clip._y - 20;
   EarnPoint_mc.points = points;
   EarnPoint_mc.gotoAndPlay("On");
}
function fnStartMusic()
{
   mapstop_mc.play();
   music_mc.fnStartMusic();
}
function fnStopMusic()
{
   music_mc.fnStopMusic();
}
function fnHelp(whichstate)
{
   if(gameMC.levelActive)
   {
      if(whichstate == "on")
      {
         fnStopFrameActions();
         GameAlert_mc.gotoAndStop("Help");
         GameAlert_mc._visible = 1;
         gameMC.pausestart = getTimer();
      }
      else
      {
         var timeaway = getTimer() - gameMC.pausestart;
         gameMC.endTime += timeaway;
         GameAlert_mc._visible = 0;
         GameAlert_mc.gotoAndStop("Park");
         fnStartFrameActions();
      }
   }
}
Array.prototype.searchArray = function(searchElement)
{
   var i = 0;
   while(i < this.length)
   {
      if(this[i] == searchElement)
      {
         return i;
      }
      i++;
   }
   return null;
};
Array.prototype.copy = function()
{
   newArray = new Array();
   count = 0;
   while(count < this.length)
   {
      newArray[count] = this[count];
      count++;
   }
   return newArray;
};
